<?php
/*
     Plugin Name: CardGate Payments
     Plugin URI: http://www.cardgate.com/
     Description: This plugin will provide several payment methods wp-e-commerce
     Version: 1.0.6
     Author: Card Gate Plus
     Author URI: http://www.cardgate.com

  	 Copyright 2010  Card Gate Plus  (email : support@cardgate.com)
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
     GNU General Public License for more details.
*/
?>
<?php
class cardgate {

	protected $_plugin_name = 'wpecommerce';
	
	// initiallize plug-in
	function __construct() {
		global $wpdb;
		global $aTranslations;
		$aTranslations = array(
		'admin_header' 		=> 'CardGate Settings',
		'admin_mode' 		=> 'Mode',
		'admin_site'			=> 'Site ID',
		'admin_hashkey'		=> 'HashKey',
		'admin_language'	=> 'Language',
		'admin_usage'		=> 'These settings apply to all Cardgate payment methods used in the wp-e-commerce plugin.',
		'no_wpsc'				=> 'You can only save the settings for this plugin, once you have installed the wp-e-commerce plugin.'
		);

		add_action('admin_menu', array(&$this, 'cardgate_config_page'));
		register_activation_hook(__FILE__, array(&$this, 'cardgate_install')); //hook for install
		register_deactivation_hook(__FILE__, array(&$this, 'cardgate_uninstall')); //hook for uninstall
		define( 'CARDGATE_PATH', plugin_dir_path(__FILE__) );
		update_option( 'cg_plugin_name', $this->_plugin_name );
		update_option( 'cg_plugin_version', $this->plugin_get_version() );
	}

	// install plug-in
	function cardgate_install() {
		return;
	}

	// unistall plug-in
	function cardgate_uninstall() {
		global $wpdb;
		$bIsSuccess = true;
		$sPmUrls = array('banktransfer', 'creditcard', 'directdebit', 'directebanking', 'giropay', 'ideal', 'mistercash', 'paypal', 'webmoney');
		foreach ($sPmUrls as $sPmUrl){
			if (file_exists(dirname(dirname(__FILE__)).'/'.WPSC_DIR_NAME.'/wpsc-merchants/cardgate'.$sPmUrl.'.php')){
				if (!unlink(dirname(dirname(__FILE__)).'/'.WPSC_DIR_NAME.'/wpsc-merchants/cardgate'.$sPmUrl.'.php')){
					$bIsSuccess = false;
				}
			}
		}
		if (!$bIsSuccess){
			die('Please remove the cardgate payment method files manually from '.dirname(dirname(__FILE__)).'/'.WPSC_DIR_NAME);
		}
		update_option( 'cg_mode','' );
		update_option( 'cg_site_id', '' );
		update_option( 'cg_hashkey', '' );
		update_option( 'cg_currency', '' );
		update_option( 'cg_language', '' );
		update_option( 'cg_plugin_name', '');
		update_option( 'cg_plugin_version', '');
	}

	// configuration page
	function cardgate_config_page() {
		add_options_page('CardGate', 'CardGate', 8, basename(__FILE__), array(&$this, 'cardgate_options_plugin'));
	}

	//configuration option
	function cardgate_options_plugin() {
		global $wpdb;
		global $aTranslations;

		if ( isset( $_POST['Submit'] ) ) {
			if ( empty($_POST) || !wp_verify_nonce($_POST['nonce162'],'action826') ){
			   print 'Sorry, your nonce did not verify.';
			   exit;
			} else {
				// process form data
				update_option( 'cg_mode',$_POST['cg_mode'] );
				update_option( 'cg_site_id', $_POST['cg_site_id'] );
				update_option( 'cg_hashkey', $_POST['cg_hashkey'] );
				update_option( 'cg_language', $_POST['cg_language'] );
				$sNotice = '';
				$bIsSuccess = true;
				$sPmUrls =  array('banktransfer', 'creditcard', 'directdebit', 'directebanking', 'giropay', 'ideal', 'mistercash', 'paypal', 'webmoney');
				foreach ($sPmUrls as $sPmUrl){
					if (!copy(dirname(__FILE__).'/cardgate'.$sPmUrl.'.php', dirname(dirname(__FILE__)).'/'.WPSC_DIR_NAME.'/wpsc-merchants/cardgate'.$sPmUrl.'.php')){
						$bIsSuccess = false;
					}
				}
				if ($bIsSuccess){
					$sNotice = 'Notice: The Cardgate payment methods were succesfully copied to the wp-e-commerce plugin.';
				} else {
					$sNotice = 'Notice: failed to copy the cardgate files to'.'../'.WPSC_DIR_NAME.'/wpsc-merchants/ <br> Please make sure you have the appropriate Write permissions for this directory.';
				}
			}
		}

		// if wp-e-commerce plugin exists, then allow the settings to be saved.
		if(defined('WPSC_DIR_NAME')){
		$sAction_url = $_SERVER['REQUEST_URI'];
		$sHtml = '<div class="wrap">
				<form name="frmCardGate" action="'.$sAction_url.'" method="post">';
		$sHtml.=wp_nonce_field('action826','nonce162');
		$sHtml.='
			<table>
				<tr>
					<td colspan="2">
						<h2>'.$aTranslations['admin_header'].'</h2><br /><br />
					</td>
				</tr>
				<tr>
					<td>'.$aTranslations['admin_mode'].'</td>
					<td>
							<select id="cg_mode" name="cg_mode">
								<option value="1"'.(get_option('cg_mode')=='1' ? ('selected="selected"'):'').'>Test</option>
								<option value="0"'.(get_option('cg_mode')=='0' ? ('selected="selected"'):'').'>Live</option>
							</select>
					</td>
				</tr>
				<tr>
					<td>'.$aTranslations['admin_site'].'</td><td><input type="text" id="cg_site_id" name="cg_site_id" value="'.get_option('cg_site_id').'" /></td>
				</tr>
				<tr>
					<td>'.$aTranslations['admin_hashkey'].'</td><td><input type="text" id="cg_hashkey" name="cg_hashkey" value="'.get_option('cg_hashkey').'"/></td>
				</tr>
				<tr>
					<td>'.$aTranslations['admin_language'].'</td>
					<td>
						<select id="cg_language" name="cg_language">
							<option value="en" '.(get_option('cg_language')=="en" ? 'selected="selected"':'').'> English</option>
							<option value="nl" '.(get_option('cg_language')=="nl" ? 'selected="selected"':'').'> Nederlands</option>
						</select>
					</td>
				</tr>
				<tr>
					<td colspan="2">'.$aTranslations['admin_usage'].'</td>
				</tr>
				<tr>
					<td colspan="2"><b>'.$sNotice.'</b></td>
				<tr>
				<tr>
					<td colspan="2">The ControlURL for the Card Gate backoffice is: <b>'.get_option('siteurl').'/index.php?gateway=cardgate</b></td>
				<tr>
				<tr>
					<td colspan="2"><input type="submit" name="Submit" value="Save" style="cursor:pointer;" /></td>
				</tr>
			</table>
			</form>
			</div>';
			} else {
				$sHtml = '
				<table>
				<tr>
					<td colspan="2">
						<h2>'.$aTranslations['admin_header'].'</h2><br /><br />
					</td>
				</tr>
				<tr>
					<td colspan="2">
						<b>'.$aTranslations['no_wpsc'].' </b>
					</td>
				</tr>';
			}
			echo $sHtml;
	}
	
	function plugin_get_version() {
	    if ( ! function_exists( 'get_plugins' ) )
	        require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
	    $plugin_folder = get_plugins( '/' . plugin_basename( dirname( __FILE__ ) ) );
	    $plugin_file = basename( ( __FILE__ ) );
	    return $plugin_folder[$plugin_file]['Version'];
	}
} //end class

$mp = new cardgate();

function cardgate_callback(){
	global $wpdb;
	if ( isset($_GET['gateway']) && $_GET['gateway'] == 'cardgate' ){
		if ( isset($_POST['ref']) && isset($_POST['hash']) && isset($_POST['status']) && isset($_POST['transactionid']) ) {
			if (get_option('cg_mode') == 0){
				$sTest = '';
			} else {
				$sTest = 'TEST';
			}
			$oPurchaseLog = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WPSC_TABLE_PURCHASE_LOGS." WHERE id=%d",$_POST['ref']));
			// login user
			$iUserId = $oPurchaseLog->user_ID;
	        wp_set_current_user( $iUserId);
	        wp_set_auth_cookie( $iUserId );
	        do_action( 'wp_login', $sUserLogin );
			$aCurrencyCode = $wpdb->get_results("SELECT `code` FROM `".WPSC_TABLE_CURRENCY_LIST."` WHERE `id`='".get_option('currency_type')."' LIMIT 1",ARRAY_A);
			$sCurrency = $aCurrencyCode[0]['code'];
			$iAmount = $oPurchaseLog->totalprice * 100;
			$sHashKey = get_option('cg_hashkey');
			$sHashVerify = md5($sTest.$_POST['transactionid'] . $sCurrency . $iAmount . $oPurchaseLog->id . $_POST['status'] . $sHashKey);
			if ( $sHashVerify == $_POST['hash'] && $_POST['status'] == 200 ) {
				// Transaction OK
				// process if it has not been processed before
				if ($oPurchaseLog->transactid != $_POST['transactionid']){
					
					$aData = array(
								'processed'  => 2,
								'transactid' => $_POST['transactionid'],
								'date'       => time(),
							);
					$sWhere = array( 'id' => $_POST['ref'] );
					$sFormat = array( '%d', '%s', '%s' );
					wpsc_update_purchase_log_details( $oPurchaseLog->sessionid, $aData, 'sessionid' );
					
					$merchant = new wpsc_merchant($oPurchaseLog->id);
					$merchant->session_id = $oPurchaseLog->sessionid;
					$merchant->set_purchase_processed_by_sessionid(3);
					//transaction_results($merchant->session_id,false);
					die($_POST['transactionid'] . '.200');
				} else {
					exit($_POST['transactionid'] . '.already processed');
				}
			} else {
				//Transaction not OK
				exit($_POST['transactionid'] . '.'.$_POST['status']);
			}
		}
	}

	if (isset($_GET['gw']) && $_GET['gw'] == 'cardgate' && isset($_GET['status']) && isset($_GET['sessionid'])){
		$oPurchaseLog = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WPSC_TABLE_PURCHASE_LOGS." WHERE sessionid=%d LIMIT 1",$_GET['sessionid']));
		// login user
		$iUserId = $oPurchaseLog->user_ID;
        wp_set_current_user( $iUserId, $sUserLogin );
        wp_set_auth_cookie( $iUserId );
        do_action( 'wp_login', $sUserLogin );

		if ($_GET['status'] == 'CANCELLED'){
			$aData = array(
						'processed'  => 6,
						'transactid' => '',
						'date'       => time(),
					);
			$sWhere = array( 'sessionid' => $_GET['sessionid'] );
			$sFormat = array( '%d', '%s', '%s' );
			$wpdb->update( WPSC_TABLE_PURCHASE_LOGS, $aData, $sWhere, $sFormat );
		} elseif ($_GET['status'] == 'SUCCESS') {
			if( get_option( 'permalink_structure' ) != '' ) {
				$sSeparator = "?";
			} else {
				$sSeparator = "&";
			}
		}
		$sTransactUrl	= get_option('transact_url');
		$sReturnURL		= $sTransactUrl.$sSeparator."sessionid=".$_GET['sessionid'];
		header("Location: ".$sReturnURL);
		exit();
	}
}
add_action('init', 'cardgate_callback')
?>