<?php

function gateway_url() {
    if ( !empty( $_SERVER['CGP_GATEWAY_URL'] ) ) {
        return $_SERVER['CGP_GATEWAY_URL'];
    } else {
        if ( get_option( 'cg_mode' ) == 1 ) {
            return "https://secure-staging.curopayments.net/gateway/cardgate/";
        } else {
            return "https://secure.curopayments.net/gateway/cardgate/";
        }
    }
}

function cg_admin_panel() {
    $sHtml = '
	<tr>
		<td>&nbsp</td>
		<td>&nbsp</td>
	</tr>
	<tr>
		<td colspan="2"> 
			 The Settings for all cardgate payment methods are done in the Wordpress Cardgate plugin.<br> <b>Version ' . get_option( 'cg_plugin_version' ) . '</b>
		</td>
	</tr>';
    return $sHtml;
}

function cg_process( $seperator, $sessionid, $payment ) {

    global $wpdb, $wpsc_cart, $wpsc_checkout, $current_user, $purchlogs, $_url;
    $oUser = $current_user->data;
    if ( !isset( $wpsc_checkout ) ) {
        $wpsc_checkout = new wpsc_checkout();
    }
    if ( !isset( $_SESSION['wpsc_sessionid'] ) ) {
        //$sessionid = ( mt_rand(100,999).time() );
        $_SESSION['wpsc_sessionid'] = $sessionid;
    }
    if ( $_SESSION['wpsc_delivery_region'] == null && $_SESSION['wpsc_selected_region'] == null ) {
        $_SESSION['wpsc_delivery_region'] = get_option( 'base_region' );
    }
    $wpsc_cart->get_shipping_option();
    $wpsc_cart->get_shipping_quotes();
    $wpsc_cart->get_shipping_method();
    $wpsc_cart->google_shipping_quotes();
    $subtotal = $wpsc_cart->calculate_subtotal();
    $base_shipping = $wpsc_cart->calculate_total_shipping();
    $tax = $wpsc_cart->calculate_total_tax();
    $total = $wpsc_cart->calculate_total_price();
    if ( $total > 0 ) {
        $sql = $wpdb->prepare( "SELECT `id` FROM `" . WPSC_TABLE_PURCHASE_LOGS . "` WHERE sessionid = %s", $sessionid );
        $purchase_log_id = $wpdb->get_var( $sql );
        $currency_code = $wpdb->get_results( "SELECT `code` FROM `" . WPSC_TABLE_CURRENCY_LIST . "` WHERE `id`='" . get_option( 'currency_type' ) . "' LIMIT 1", ARRAY_A );
        if ( !in_array( $currency_code[0]['code'], array( 'EUR', 'USD', 'GBP' ) ) ) {
            die( 'The Currency Type setting of this webshop is not set to a currency that can be paid with via Card Gate Plus.' );
        }
        if ( get_option( 'permalink_structure' ) != '' ) {
            $separator = "?";
        } else {
            $separator = "&";
        }
        if ( $payment == 'ideal' ) {
            $bank = $_POST['bank'];
        } else {
            $bank = '-';
        }
        if ( get_option( 'cg_mode' ) == 1 ) {
            $sPrefix = 'TEST';
        } else {
            $sPrefix = '';
        }
        $cg_total = number_format( ($total * 100 ), 0, '.', '' );
        $hash = md5( $sPrefix . get_option( 'cg_site_id' ) . $cg_total . $purchase_log_id . get_option( 'cg_hashkey' ) );
        $transact_url = get_option( 'transact_url' );
        $returnURL = $transact_url . $separator . 'gw=cardgate&sessionid=' . $sessionid;
        $data = array();
        $data['siteid'] = get_option( 'cg_site_id' );
        $data['test'] = get_option( 'cg_mode' );
        $data['language'] = get_option( 'cg_language' );
        $data['hash'] = $hash;
        $data['return_url'] = $returnURL . '&status=SUCCESS';
        $data['return_url_failed'] = $returnURL . '&status=CANCELLED';
        $data['amount'] = $cg_total;
        $data['description'] = 'transaction ' . $sessionid;
        $data['ref'] = $purchase_log_id;
        $data['option'] = $payment;
        $data['suboption'] = $bank;
        $data['first_name'] = $_POST['collected_data'][2];
        $data['last_name'] = $_POST['collected_data'][3];
        $data['address'] = $_POST['collected_data'][4];
        $data['postal_code'] = $_POST['collected_data'][8];
        $data['city'] = $_POST['collected_data'][5];
        $data['country'] = $_POST['collected_data'][7][0];
        $data['email'] = $_POST['collected_data'][9];
        $data['currency'] = $currency_code[0]['code'];
        $data['plugin_name'] = get_option( 'cg_plugin_name' );
        $data['plugin_version'] = get_option( 'cg_plugin_version' );

        // Create Form to post to Cardgate
        $output = '
			<form id="cardgate_form" name="cardgate_form" method="post" action="' . gateway_url() . '">';

        foreach ( $data as $n => $v ) {
            $output .= '<input type="hidden" name="' . $n . '" value="' . $v . '" />';
        }

        $output .= '<p>You are being transferred to Card Gate...</p></form>';
        $output .= '<script language="javascript" type="text/javascript">document.getElementById("cardgate_form").submit();</script>';
        print $output;
        exit();
    }
}

?>